/*
 * main.c
 *
 *  Created on: Jul 23, 2016
 *      Author: esp8266
 */

#include <stdlib.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include <lcd/lcd.h>
#include <io/include/io_helper.h>
#include "oscillator.h"
#include "amplitude_adc.h"
#include "mode.h"
#include "scanner.h"
#include "display.h"

static inline void init()
{
	lcd_init(LCD_DISP_ON);
	amp_init();
	osc_init();
}

static inline void main_loop()
{
//	scan_on_period_scanned = print_scanned_mode;
	scan_on_mode_detected = print_modes;
	scan_on_chase_change = print_chase;
//	while (1)
	{
		scan_scan();
//		scan_chase();

//		uint16_t sample = amp_get_sample();
//		char buf[16];
//		itoa(sample, buf, 10);
//		lcd_gotoxy(0,0);
//		lcd_puts(buf);
//		lcd_puts("   ");
//		_delay_ms(300);
	}
}

int main(void)
{
	init();
	lcd_puts_p(PSTR("Hello ReedWarbler"));
	main_loop();
	return 0;
}
